<?php

/*Main function*/
function mo_ldap_settings() {
	if( isset( $_GET[ 'tab' ] ) ) {
		$active_tab = $_GET[ 'tab' ];
	} else {
		$active_tab = 'config';
	}
	?>
	<h2>LDAP/Active Directory Login for Cloud</h2>
	<?php
		if(!Mo_Ldap_Util::is_curl_installed()) {
			?>
			
			<div id="help_curl_warning_title" class="mo_ldap_title_panel">
				<p><a target="_blank" style="cursor: pointer;"><font color="#FF0000">Warning: PHP cURL extension is not installed or disabled. <span style="color:blue">Click here</span> for instructions to enable it.</font></a></p>
			</div>
			<div hidden="" id="help_curl_warning_desc" class="mo_ldap_help_desc">
					<ul>
						<li>Step 1:&nbsp;&nbsp;&nbsp;&nbsp;Open php.ini file located under php installation folder.</li>
						<li>Step 2:&nbsp;&nbsp;&nbsp;&nbsp;Search for <b>extension=php_curl.dll</b> </li>
						<li>Step 3:&nbsp;&nbsp;&nbsp;&nbsp;Uncomment it by removing the semi-colon(<b>;</b>) in front of it.</li>
						<li>Step 4:&nbsp;&nbsp;&nbsp;&nbsp;Restart the Apache Server.</li>
					</ul>
					For any further queries, please <a href="mailto:info@miniorange.com">contact us</a>.								
			</div>
					
			<?php
		}
		if(!Mo_Ldap_Util::is_extension_installed('mcrypt')) {
			?>
			<font color="#FF0000">(Warning: <a target="_blank" href="http://php.net/manual/en/mcrypt.installation.php">PHP mcrypt extension</a> is not installed or disabled)</font> <span id="help_mcrypt_warning_title" class="mo_ldap_title_panel">
				<a target="_blank" style="cursor: pointer;"><span style="color:blue">(Why we need it?)</span></a></span>
			
			<div hidden="" id="help_mcrypt_warning_desc" class="mo_ldap_help_desc">
					<ul>
						<li>PHP Mcrypt extension is required to Encrypt LDAP configuration in such a way as to make it unreadable by anyone except those possessing special knowledge (usually referred to as a "key") that allows them to change the information back to its original, readable form.</li>
						<li>Encryption is important because it allows you to securely protect your LDAP configuration that you don't want anyone else to have access to.</li>
					</ul>
					For any further queries, please <a href="mailto:info@miniorange.com">contact us</a>.								
			</div>		
			<?php
		}
		
	?>
	<div class="mo2f_container">
		<h2 class="nav-tab-wrapper">
			<a class="nav-tab <?php echo $active_tab == 'config' ? 'nav-tab-active' : ''; ?>" href="<?php echo add_query_arg( array('tab' => 'config'), $_SERVER['REQUEST_URI'] ); ?>">LDAP Configuration</a>
			<a class="nav-tab <?php echo $active_tab == 'rolemapping' ? 'nav-tab-active' : ''; ?>" href="<?php echo add_query_arg( array('tab' => 'rolemapping'), $_SERVER['REQUEST_URI'] ); ?>">Role Mapping</a>
			<a class="nav-tab <?php echo $active_tab == 'attributemapping' ? 'nav-tab-active' : ''; ?>" href="<?php echo add_query_arg( array('tab' => 'attributemapping'), $_SERVER['REQUEST_URI'] ); ?>">Attribute Mapping</a>
			<a class="nav-tab <?php echo $active_tab == 'default' ? 'nav-tab-active' : ''; ?>" href="<?php echo add_query_arg( array('tab' => 'default'), $_SERVER['REQUEST_URI'] ); ?>">Example LDAP Configuration</a>
			<a class="nav-tab <?php echo $active_tab == 'pricing' ? 'nav-tab-active' : ''; ?>" href="<?php echo add_query_arg( array('tab' => 'pricing'), $_SERVER['REQUEST_URI'] ); ?>">Licensing Plans</a>
			<a class="nav-tab <?php echo $active_tab == 'troubleshooting' ? 'nav-tab-active' : ''; ?>" href="<?php echo add_query_arg( array('tab' => 'troubleshooting'), $_SERVER['REQUEST_URI'] ); ?>">Troubleshooting</a>
		</h2>
		<table style="width:100%;">
			<tr>
				<td style="width:65%;vertical-align:top;">
					<?php
							if($active_tab == "default") {
								mo_ldap_default_config_page();
							} else if($active_tab == 'rolemapping'){ 
								mo_ldap_rolemapping();
							} else if($active_tab == 'attributemapping'){ 
									mo_ldap_cloud_attribute_mapping_page();
							} else if($active_tab == 'troubleshooting'){ 
								mo_ldap_troubleshooting();
							} else if($active_tab == 'pricing'){
									mo_ldap_show_pricing_page();
							}else {
								if (get_option ( 'mo_ldap_verify_customer' ) == 'true') {
									mo_ldap_login_page();
								} else if (trim ( get_option ( 'mo_ldap_admin_email' ) ) != '' && trim ( get_option ( 'mo_ldap_admin_api_key' ) ) == '' && get_option ( 'mo_ldap_new_registration' ) != 'true') {
									mo_ldap_login_page();
								} else if(get_option('mo_ldap_registration_status') == 'MO_OTP_DELIVERED_SUCCESS' || get_option('mo_ldap_registration_status') == 'MO_OTP_VALIDATION_FAILURE' || get_option('mo_ldap_registration_status') == 'MO_OTP_DELIVERED_FAILURE'){
									mo_ldap_show_otp_verification();
								}else if (! Mo_Ldap_Util::is_customer_registered()) {
									mo_ldap_registration_page();
								} else {
									mo_ldap_configuration_page();
								}
							}
					?>
				</td>
				<td style="vertical-align:top;padding-left:1%;">
					<?php echo mo_ldap_support(); ?>
				</td>
			</tr>
		</table>
	</div>
	<?php
}
/*End of main function*/

/* Create Customer function */
function mo_ldap_registration_page(){
	update_option ( 'mo_ldap_new_registration', 'true' );
	
	$current_user = wp_get_current_user();
	
	?>


<!--Register with miniOrange-->
<form name="f" method="post" action="">
	<input type="hidden" name="option" value="mo_ldap_register_customer" />
	<p>Just complete the short registration below to configure your own LDAP Server. Or you can test using our LDAP Server. Please enter a valid email id that you have access to. You will be able to move forward after verifying an OTP that we will send to this email.</p>
	<div class="mo_ldap_table_layout" style="min-height: 274px;">
		<h3>Register with miniOrange</h3>
		<div id="panel1">
			<table class="mo_ldap_settings_table">
				<tr>
					<td><b><font color="#FF0000">*</font>Website/Company:</b></td>
					<td><input class="mo_ldap_table_textbox" type="tel" id="company"
						name="company"
						title="Website/Company"
						value="<?php echo $_SERVER['SERVER_NAME']; ?>"
						required placeholder="Company Name" />
					</td>
				</tr>
				<tr>
					<td><b><font color="#FF0000">*</font>Email:</b></td>
					<td><input class="mo_ldap_table_textbox" type="email" name="email"
						required placeholder="person@example.com"
						value="<?php echo $current_user->user_email; ?>" /></td>
				</tr>

				<tr>
					<td><b>Cellphone number:</b></td>
					<td><input class="mo_ldap_table_textbox" type="tel" id="phone"
						pattern="[\+]\d{11,14}|[\+]\d{1,4}([\s]{0,1})(\d{0}|\d{9,10})" name="phone" 
						title="Phone with country code eg. +1xxxxxxxxxx"
						placeholder="Phone with country code eg. +1xxxxxxxxxx"
						value="<?php echo get_option('mo_ldap_admin_phone');?>" />
						<i>We will call only if you call for support</i><br></td>
				</tr>
				<tr>
					<td><b>First Name:</b></td>
					<td><input class="mo_ldap_table_textbox" type="tel" id="fname"
						name="fname"
						title="First Name"
						value="<?php echo $current_user->user_firstname; ?>"
						placeholder="First Name" />
					</td>
				</tr>
				<tr>
					<td><b>Last Name:</b></td>
					<td><input class="mo_ldap_table_textbox" type="tel" id="lname"
						name="lname"
						title="Last Name"
						value="<?php echo $current_user->user_lastname; ?>"
						placeholder="Last Name" />
					<br><br></td>
				</tr>
				<tr>
					<td><b><font color="#FF0000">*</font>Password:</b></td>
					<td><input class="mo_ldap_table_textbox" required type="password"
						name="password" placeholder="Choose your password (Min. length 6)" />
					</td>
				</tr>
				<tr>
					<td><b><font color="#FF0000">*</font>Confirm Password:</b></td>
					<td><input class="mo_ldap_table_textbox" required type="password"
						name="confirmPassword" placeholder="Confirm your password" /></td>
				</tr>
				<tr>
					<td>&nbsp;</td>
					<td><input type="submit" value="Save"
						class="button button-primary button-large" /></td>
				</tr>
			</table>
		</div>
	</div>
</form>
<script>
	jQuery("#phone").intlTelInput();
</script>
<?php
}
/* End of Create Customer function */

/* Login for customer*/
function mo_ldap_login_page() {
	?>
		<!--Verify password with miniOrange-->
		<form name="f" method="post" action="">
			<input type="hidden" name="option" value="mo_ldap_verify_customer" />
			<div class="mo_ldap_table_layout">
				<h3>Login with miniOrange</h3>
				<p><b>It seems you already have an account with miniOrange. Please enter your miniOrange email and password.<br/> <a href="#mo_ldap_forgot_password_link">Click here if you forgot your password?</a></b></p>
					<table class="mo_ldap_settings_table">
						<tr>
							<td><b><font color="#FF0000">*</font>Email:</b></td>
							<td><input class="mo_ldap_table_textbox" type="email" name="email"
								required placeholder="person@example.com"
								value="<?php echo get_option('mo_ldap_admin_email');?>" /></td>
						</tr>
						<tr>
							<td><b><font color="#FF0000">*</font>Password:</b></td>
							<td><input class="mo_ldap_table_textbox" required type="password"
								name="password" placeholder="Enter your miniOrange password" /></td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td><input type="submit" class="button button-primary button-large" />
							<input type="button" name="mo_ldap_goback" id="mo_ldap_goback" value="Back" class="button button-primary button-large" /></td>
						</tr>
					</table>
				</div>
			
		</form>
		<form name="f" method="post" action="" id="mo_ldap_goback_form">
				<input type="hidden" name="option" value="mo_ldap_go_back"/>
		</form>
		<form name="f" method="post" action="" id="mo_ldap_forgotpassword_form">
				<input type="hidden" name="option" value="mo_ldap_forgot_password_form_option"/>
		</form>
		<script>
			jQuery('#mo_ldap_goback').click(function(){
				jQuery('#mo_ldap_goback_form').submit();
			});
			jQuery('a[href="#mo_ldap_forgot_password_link"]').click(function(){
				jQuery('#mo_ldap_forgotpassword_form').submit();
			});
		</script>
	<?php
}
/* End of Login for customer*/

function mo_ldap_link() {
	?>
	<a href="http://miniorange.com/wordpress-ldap-login" style="display:none">Login to WordPress using LDAP</a>
	<a href="http://miniorange.com/cloud-identity-broker-service" style="display:none">Cloud Identity broker service</a>
	<a href="http://miniorange.com/strong_auth" style="display:none;"></a>
	<a href="http://miniorange.com/single-sign-on-sso" style="display:none;"></a>
	<a href="http://miniorange.com/fraud" style="display:none;"></a>
	<?php
}

/* Configure LDAP function */
function mo_ldap_configuration_page(){
	$default_config = get_option('mo_ldap_default_config');
	
	$server_url = isset($_POST['ldap_server']) ? $_POST['ldap_server'] :
		( get_option('mo_ldap_server_url') ? Mo_Ldap_Util::decrypt(get_option('mo_ldap_server_url')) : '');
	$dn = isset($_POST['dn']) ? $_POST['dn'] :
		(get_option('mo_ldap_server_dn') ? Mo_Ldap_Util::decrypt(get_option('mo_ldap_server_dn')) : '');
	$admin_password = isset($_POST['admin_password']) ? $_POST['admin_password'] :
		(get_option('mo_ldap_server_password') ? Mo_Ldap_Util::decrypt(get_option('mo_ldap_server_password')) : '');
	$search_base = isset($_POST['search_base']) ? $_POST['search_base'] :
		(get_option('mo_ldap_search_base') ? Mo_Ldap_Util::decrypt(get_option('mo_ldap_search_base')) : '');
	$search_filter = isset($_POST['search_filter']) ? $_POST['search_filter'] :
		(get_option('mo_ldap_search_filter') ? Mo_Ldap_Util::decrypt(get_option('mo_ldap_search_filter')) : '');
		
		
	?>
		<div class="mo_ldap_small_layout" style="margin-top:0px;">
			<!-- Toggle checkbox -->
			<form name="f" id="enable_login_form" method="post" action="">
				<input type="hidden" name="option" value="mo_ldap_enable" />
				<h3>Enable login using LDAP</h3>
				
				
				
				<?php 
					$serverUrl = get_option('mo_ldap_server_url');
					if(isset($serverUrl) && $serverUrl != ''){?>
						<input type="checkbox" id="enable_ldap_login" name="enable_ldap_login" value="1" <?php checked(get_option('mo_ldap_enable_login') == 1);?> />Enable LDAP login
				<?php } else{?>
						<input type="checkbox" id="enable_ldap_login" name="enable_ldap_login" value="1" <?php checked(get_option('mo_ldap_enable_login') == 1);?> disabled />Enable LDAP login
				<?php }?>
				<p>Enabling LDAP login will protect your login page by your configured LDAP. <b>Please check this only after you have successfully tested your configuration</b> as the default WordPress login will stop working.</p>
			</form>
			<script>
				jQuery('#enable_ldap_login').change(function() {
					jQuery('#enable_login_form').submit();
				});
			</script>
			<br/>
			
			<?php  if(get_option('mo_ldap_enable_login')){ ?>
			<form name="f" id="enable_both_login_form" method="post" action="">
				<input type="hidden" name="option" value="mo_ldap_enable_both_login" />
					<input type="checkbox" id="mo_ldap_enable_both_login" name="mo_ldap_enable_both_login" value="1" <?php checked(get_option('mo_ldap_enable_both_login') == 1);?> />Authenticate user from both LDAP and WordPress ( This will allow users to use either of WordPress credentials or LDAP credentials. )
			</form>
			<script>
				jQuery('#mo_ldap_enable_both_login').change(function() {
					jQuery('#enable_both_login_form').submit();
				});
			</script>
			<br>
			<?php } ?>
			
			
			<!-- Toggle checkbox -->
			<form name="f" id="enable_register_user_form" method="post" action="">
				<input type="hidden" name="option" value="mo_ldap_register_user" />
				<input type="checkbox" id="mo_ldap_register_user" name="mo_ldap_register_user" value="1" <?php checked(get_option('mo_ldap_register_user') == 1);?> />Enable Auto Registering users if they do not exist in WordPress
				</form>
			<script>
				jQuery('#mo_ldap_register_user').change(function() {
					jQuery('#enable_register_user_form').submit();
				});
			</script>
			<br/>
		</div>

		<div class="mo_ldap_small_layout">
			<script>
				function ping_server(){

					var isFirewallAllowed = document.getElementById('firewall_allowed').checked;

					if(!isFirewallAllowed){
						alert("Check the above option to confirm that you have allowed access to the LDAP server from the given IP addresses.");
					} else{
						var ldapServerUrl = document.getElementById('ldap_server').value;
						if(!ldapServerUrl || ldapServerUrl.trim() == ""){
							alert("Enter LDAP Server URL");
						} else{
							var option = document.getElementById("mo_ldap_configuration_form_action").value = "mo_ldap_ping_server";
							//alert(document.getElementById("mo_ldap_configuration_form_action").value);
							var configForm = document.getElementById("mo_form1");
							//alert(configForm);
							configForm.submit();
						}
					}
				}
			</script>
			<!-- Save LDAP Configuration -->
			<form id="mo_form1" name="f" method="post" action="">
				<input id="mo_ldap_configuration_form_action" type="hidden" name="option" value="mo_ldap_save_config" />
				<!-- Copy default values to configuration -->
				<p><strong style="font-size:14px;">NOTE: </strong> You need to find out the values for the below given fields from your LDAP Administrator.</strong></p>
				<p><strong style="font-size:14px;">NOTE: </strong>You need to allow incoming requests from hosts - <font style="color:blue">52.6.168.155</font> and <font style="color:blue">52.6.204.243</font> by a firewall rule for the port <font style="color:blue">389</font>(<font style="color:blue">636</font> for SSL or ldaps) on LDAP Server.</p>
				<h3 class="mo_ldap_left">LDAP Connection Information</h3>
				<ul>
					<li><input type="checkbox" name="firewall_allowed" id="firewall_allowed" /> <b>Allowed incoming requests from hosts - <font style="color:blue">52.6.168.155</font> and <font style="color:blue">52.6.204.243</font> by a firewall rule for the port <font style="color:blue">389</font>(<font style="color:blue">636</font> for SSL or ldaps) on LDAP Server.</b></li>
				</ul>
				<div id="panel1">
					<table class="mo_ldap_settings_table">
						<tr>
							<td style="width: 24%"><b><font color="#FF0000">*</font>LDAP Server:</b></td>
							<td><input class="mo_ldap_table_textbox" type="url" id="ldap_server" name="ldap_server" required placeholder="ldap://<server_address or IP>:<port>" value="<?php echo $server_url?>" /></td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td><i>Specify the host name for the LDAP server eg: ldap://myldapserver.domain:389 , ldap://89.38.192.1:389. When using SSL, the host may have to take the form ldaps://host:636.</i></td>
						</tr>
						<tr>
							<td></td>
							<td><input type="button" class="button button-primary button-large" onclick="ping_server();" value="Contact LDAP Server" />&nbsp;&nbsp;<span id="pingResult"></span></td>
							<td></td>
						</tr>
						<tr>
							<td></td>
							<td float="right"><i>Confirm connection to your LDAP server from <font style="color:blue">52.6.168.155</font> , <font style="color:blue">52.6.204.243</font> through port <font style="color:blue">389</font>(<font style="color:blue">636</font> for SSL or ldaps).</i></td>
						</tr>
						<tr><td>&nbsp;</td></tr>
						<tr>
							<td><b><font color="#FF0000">*</font>Service Account DN:</b></td>
							<td><input class="mo_ldap_table_textbox" type="text" id="dn" name="dn" required placeholder="CN=service,DC=domain,DC=com" value="<?php echo $dn?>" /></td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td><i>Specify the Service Account DN(distinguished Name) of the LDAP server. e.g. cn=username,cn=group,dc=domain,dc=com<br/>uid=username,ou=organisational unit,dc=domain,dc=com.</i></td>
						</tr>
						<tr><td>&nbsp;</td></tr>
						<tr>
							<td><b><font color="#FF0000">*</font>Admin Password:</b></td>
							<td><input class="mo_ldap_table_textbox" required type="password" name="admin_password" placeholder="Enter password of Service Account" value="<?php echo $admin_password?>"/></td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td><i>Password for the Service Account in the LDAP Server.</i></td>
						</tr>
						<tr><td>&nbsp;</td></tr>
					</table>
				</div>
				<h3>LDAP User Mapping Configuration</h3>
				<div id="panel1">
					<table class="mo_ldap_settings_table">
						<tr><td>&nbsp;</td></tr>
						<tr>
							<td><b><font color="#FF0000">*</font>SearchBase(s):</b></td>
							<td><input class="mo_ldap_table_textbox" type="text" id="search_base" name="search_base" required placeholder="dc=domain,dc=com" value="<?php echo $search_base?>" /></td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td><i>This is the LDAP Tree under which we will search for the users for authentication.  If we are not able to find a user in LDAP it means they are not present in this search base or any of its sub trees. They may be present in some other search base.<br> Provide the distinguished name of the Search Base object. <b>eg. cn=Users,dc=domain,dc=com</b>. 
							
							<?php if(get_option('mo_ldap_free_version')){ ?>
								<br><br>
								<b>Multiple Search Bases are supported in the <a href="<?php echo add_query_arg( array('tab' => 'pricing'), $_SERVER['REQUEST_URI'] ); ?>">Premium version</a> of the plugin.</b></i><br><br></td>
							<?php }else{ ?>
								If you have users in different locations in the directory(OU's), separate the distinguished names of the search base objects by a semi-colon(;). <b>eg. cn=Users,dc=domain,dc=com; ou=people,dc=domian,dc=com</b></i></td>
							<?php } ?></td>
						</tr>
						<tr><td>&nbsp;</td></tr>
						
						<?php if(get_option('mo_ldap_free_version')){ ?>
						<tr>
							<td><b><font color="#FF0000">*</font>Search Filter:</b></td>
							<td><b><?php echo Mo_Ldap_Util::decrypt(get_option('mo_ldap_search_filter')); ?></b></td>
						</tr>
						<tr>
							<td>&nbsp;</td>
							<td>
								
								<i>You can login using your email, cn or any other LDAP attribute of your choice through the Search Filter.<br><b> 
								<br>
								Configurable Search Filter is supported in the <a href="<?php echo add_query_arg( array('tab' => 'pricing'), $_SERVER['REQUEST_URI'] ); ?>">Premium version</a> of the plugin.</b></i>
							</td>
						</tr>
						<?php }else{ ?>
						<tr>
							<td><b><font color="#FF0000">*</font>LDAP Search Filter:</b></td>
							<td><input class="mo_ldap_table_textbox" type="text" id="search_filter" name="search_filter" required placeholder="(&(objectClass=*)(cn=?))" value="<?php echo $search_filter?>" /></td>
						</tr>
						
						<tr>
							<td>&nbsp;</td>
							<td><i>This field is important for two reasons. <br>1. While searching for users, this is the attribute that is going to be matched to see if the user exists.  <br>2. If you want your users to login with their username or firstname.lastname or email - you need to specify those options in this field. e.g. <b>(&(objectClass=*)(&lt;LDAP_ATTRIBUTE&gt;=?))</b>. Replace <b>&lt;LDAP_ATTRIBUTE&gt;</b> with the attribute where your username is stored. Some common attributes are 
							<ol>
							<table>
								<tr><td style="width:50%">common name</td><td>(&(objectClass=*)(<b>cn</b>=?))</td></tr>
								<tr><td>email</td><td>(&(objectClass=*)(<b>mail</b>=?))</td></tr> 
								<tr><td>logon name</td><td>(&(objectClass=*)(<b>sAMAccountName</b>=?))<br/>(&(objectClass=*)(<b>userPrincipalName</b>=?))</td></tr>
								<tr><td>custom attribute where you store your WordPress usernames use</td> <td>(&(objectClass=*)(<b>customAttribute</b>=?))</td></tr>
								
							</table><br>
							You can even allow logging in with multiple attributes e.g. you can allow logging in with username or email e.g. (&(objectClass=*)(<b>|</b>(<b>cn=?</b>)(<b>mail=?</b>)))
							</ol></td>
						</tr>
						<tr><td></td><td>Please make clear that the attributes that we are showing are examples and the actual ones could be different. These should be confirmed with the LDAP Admin.</td></tr>
						
						<?php } ?>
						</tr>
						<tr><td>&nbsp;</td></tr>
						<tr>
							<td>&nbsp;</td>
							<td><input type="submit" class="button button-primary button-large" value="Test Connection & Save"/>&nbsp;&nbsp; <input
								type="button" id="conn_help" class="help" value="Troubleshooting" /></td>
						</tr>
						<tr>
							<td colspan="2" id="conn_troubleshoot" hidden>
								<p>
									<strong>Are you having trouble connecting to your LDAP server from this plugin?</strong>
									<ol>
										<li>Please check to make sure that all the values entered in the <b>LDAP Connection Information</b> section are correct.</li>
										<li>If all those values are correct, then you need to make sure that if there is a firewall, you open the firewall to allow incoming requests to your LDAP. Please open port 389(636 for SSL or ldaps). Host - 52.6.168.155 , 52.6.204.243 - This is the host from where the LDAP connection as well as authentication requests are going to be made.</li>
										<li>If you are still having problems, submit a query using the support panel on the right hand side.</li>
									</ol>
								</p>
							</td>
						</tr>
					</table>
				</div>
			</form>
		</div>
		<div class="mo_ldap_small_layout">
		<!-- Authenticate with LDAP configuration -->
		<form name="f" method="post" action="">
			<input type="hidden" name="option" value="mo_ldap_test_auth" />
			<h3>Test Authentication</h3>
			<?php if(get_option('mo_ldap_free_version')){ ?>
					<p>Wordpress username is mapped to the <b>CN(common name)</b> attribute in LDAP. Ensure that you have an administrator user in LDAP with the same common name value. <br><b>The support for custom username attribute is in the <a href="<?php echo add_query_arg( array('tab' => 'pricing'), $_SERVER['REQUEST_URI'] ); ?>">Premium</a> version of the plugin.</b></p><br>
			<?php } ?>
			<div id="test_conn_msg"></div>
			<div id="panel1">
				<table class="mo_ldap_settings_table">
					<tr>
						<td style="width: 24%"><b><font color="#FF0000">*</font>Username:</b></td>
						<td><input class="mo_ldap_table_textbox" type="text" name="test_username" required placeholder="Enter username"/></td>
					</tr>
					<tr>
						<td><b><font color="#FF0000">*</font>Password:</b></td>
						<td><input class="mo_ldap_table_textbox" type="password" name="test_password" required placeholder="Enter password" /></td>
					</tr>
					<tr>
						<td>&nbsp;</td>
						<td><input type="submit" class="button button-primary button-large" value="Test Authentication"/>&nbsp;&nbsp; <input
								type="button" id="auth_help" class="help" value="Troubleshooting" /></td>
					</tr>
					<tr>
						<td colspan="2" id="auth_troubleshoot" hidden>
							<p>
								<strong>User is not getting authenticated? Check the following:</strong>
								<ol>
									<li>The username-password you are entering is correct.</li>
									<li>The user is present in the search bases you have specified against <b>SearchBase(s)</b> above.</li>
								</ol>
							</p>
						</td>
					</tr>
				</table>
			</div>
		</form>
		</div>
	<?php
}
/* End of Configure LDAP function */

/* Test Default Configuration*/
function mo_ldap_default_config_page() {
	$default_config = get_option('mo_ldap_default_config');
	?>
	<div class="mo_ldap_table_layout">
		<!-- Test connection for default configuration -->
		<form name="f" method="post" action="">
			<input type="hidden" name="option" value="mo_ldap_test_default_config" />

				<h3>Example Configuration</h3>
				<p><b><font color="#FF0000">NOTE : The values given below are mock values. So if you try copying them to the LDAP configuration tab, IT WILL NOT WORK.</font></b> You need to provide actual LDAP configuration in the LDAP configuration tab. If you need any help, please contact us at info@miniorange.com</p>
				<div id="panel1">
					<table class="mo_ldap_settings_table">
						<tr>
							<td><b>LDAP Server:</b></td>
							<td style="width:65%"><input class="mo_ldap_table_textbox fixed" type="url" value="<?php echo $default_config['server_url'];?>" readonly/></td>
						</tr>
						<tr>
							<td><b>Service Account DN:</b></td>
							<td><input class="mo_ldap_table_textbox fixed" type="text" name="dn" value="<?php echo $default_config['service_account_dn']; ?>" readonly/></td>
						</tr>
						<tr>
							<td><b>Admin Password:</b></td>
							<td><input class="mo_ldap_table_textbox fixed" type="password" value="<?php echo $default_config['admin_password']; ?>" readonly/></td>
						</tr>
						<tr>
							<td><b>DN Attribute:</b></td>
							<td><input class="mo_ldap_table_textbox fixed" type="text" value="<?php echo $default_config['dn_attribute']; ?>" readonly/></td>
						</tr>
						<tr>
							<td><b>SearchBase:</b></td>
							<td><input class="mo_ldap_table_textbox fixed" type="text" value="<?php echo $default_config['search_base'];?>" readonly/></td>
						</tr>
						<tr>
							<td><b>LDAP Search Filter:</b></td>
							<td><input class="mo_ldap_table_textbox fixed" type="text" value="<?php echo $default_config['search_filter'];?>" readonly/></td>
						</tr>
					</table>
				</div>
		</form>

	</div>
	<?php
}
/* End of Test Default Configuration*/

/* Show OTP verification page*/
function mo_ldap_show_otp_verification(){
	?>
		<div class="mo_ldap_table_layout">
			
				<table class="mo_ldap_settings_table">
		<!-- Enter otp -->
					<form name="f" method="post" id="ldap_form" action="">
						<input type="hidden" name="option" value="mo_ldap_validate_otp" />
						<h3>Verify Your Email</h3>
						<tr>
							<td><b><font color="#FF0000">*</font>Enter OTP:</b></td>
							<td colspan="2"><input class="mo_ldap_table_textbox" autofocus="true" type="text" name="otp_token" required placeholder="Enter OTP" style="width:61%;" />
							 &nbsp;&nbsp;<a style="cursor:pointer;" onclick="document.getElementById('resend_otp_form').submit();">Resend OTP</a></td>
						</tr>
						<tr><td colspan="3"></td></tr>
						<tr>
							<td>&nbsp;</td>
							<td>
							<input type="submit" value="Validate OTP" class="button button-primary button-large" />
							<a id="back_button" href=""class="button button-primary button-large">Cancel</a>
							</td>

					</form>
					<form name="f" id="resend_otp_form" method="post" action="">
							<td>
							<input type="hidden" name="option" value="mo_ldap_resend_otp"/>
							</td>
						</tr>
					</form>
				</table>
			
		</div>
		<script>
			jQuery('#back_button').click(function() {
				<?php update_option( 'mo_ldap_registration_status', '' );?>
				window.location.reload();
			}
		</script>
<?php
}
/* End Show OTP verification page*/



/* Role Mapping */
function mo_ldap_rolemapping() {
	?>
<div class="mo_ldap_small_layout" style="margin-top:0px;">

		<form name="f" id="enable_role_mapping_form" method="post" action="">
				<input type="hidden" name="option" value="mo_ldap_enable_role_mapping" />
				<h3>LDAP Groups to WP User Role Mapping</h3>
				<input type="checkbox" id="enable_ldap_role_mapping" name="enable_ldap_role_mapping"  value="1" <?php checked(get_option('mo_ldap_enable_role_mapping') == 1);?>  />Enable Role Mapping
				<p>Enabling Role Mapping will automatically map Users from LDAP Groups to below selected WordPress Role. Role mapping will not be applicable for primary admin of wordpress.</p>
			</form>


	<form id="role_mapping_form" name="f" method="post" action="">
				<input id="mo_ldap_user_mapping_form" type="hidden" name="option" value="mo_ldap_save_role_mapping" />
				
				<div id="panel1">
					<table class="mo_ldap_mapping_table"  style="width:90%">
							<tr>
								<td colspan=2><i> Default role will be assigned to all users for which mapping is not specified.</i></td>
							</tr>
							<tr>
							<td><font style="font-size:13px;font-weight:bold;">Default Role </font></td>
							<td>
								<select name="mapping_value_default" style="width:100%" id="default_group_mapping">
								   <?php
								   	 if(get_option('mo_ldap_mapping_value_default'))
								   	 	$default_role = get_option('mo_ldap_mapping_value_default');
								   	 else 
								   	 	$default_role = get_option('default_role');
								   	 wp_dropdown_roles($default_role); ?>
								</select>
								<select style="display:none" id="wp_roles_list">
								   <?php wp_dropdown_roles($default_role); ?>
								</select>
							</td>
						</tr>
						<tr><td>&nbsp;</td></tr>
						
						</table>
						<table class="mo_ldap_mapping_table" id="ldap_role_mapping_table" style="width:90%;">
						<?php if(get_option('mo_ldap_free_version')){ ?>
			
						<tr><td style="width:160%;"><b>Add More Mapping - This feature is available in the <a href="<?php echo add_query_arg( array('tab' => 'pricing'), $_SERVER['REQUEST_URI'] ); ?>">Premium version</a> of the plugin.</b><br></td>
						</tr>
												
						<?php }else{ ?>
						<tr>
							<td style="width:50%"><b>LDAP Group Name</b></td>
							<td style="width:50%"><b>WordPress Role</b></td>
						</tr>
						
						<?php 
						$mapping_count = 1;
						if(is_numeric(get_option('mo_ldap_role_mapping_count')))
							$mapping_count = intval(get_option('mo_ldap_role_mapping_count'));
						for($i = 1 ; $i <= $mapping_count ; $i++){
							 
						?>
						<tr>
							<td><input class="mo_ldap_table_textbox" type="text" name="mapping_key_<?php echo $i;?>"
								 value="<?php echo get_option('mo_ldap_mapping_key_'.$i);?>"  placeholder="cn=group,dc=domain,dc=com" />
							</td>
							<td>
								<select name="mapping_value_<?php echo $i;?>" id="role" style="width:100%">
								   <?php wp_dropdown_roles( get_option('mo_ldap_mapping_value_'.$i) ); ?>
								</select>
							</td>
						</tr>
						<?php }
						
						if($mapping_count==0){ ?>
						<tr>
							<td><input class="mo_ldap_table_textbox" type="text" name="mapping_key_1"
								 value="" placeholder="cn=group,dc=domain,dc=com" />
							</td>
							<td>
								<select name="mapping_value_1" id="role" style="width:100%">
								   <?php wp_dropdown_roles(); ?>
								</select>
							</td>
						</tr>
						<?php }
						
						?>
						</table>
						<table>
						<tr><td><a style="cursor:pointer" id="add_mapping">Add More Mapping</a><br><br></td><td>&nbsp;</td></tr>
						
						
						<tr>
								<td colspan=2><i> Specify attribute which stores group names to which LDAP Users belong.</i></td>
							</tr>
							<tr>
							<td style="width:50%"><font style="font-size:13px;font-weight:bold;">LDAP Group Attributes Name </font>
							</td>
							<td>
								  <?php
								   	 if(!get_option('mo_ldap_mapping_memberof_attribute'))
								   	 	update_option( 'mo_ldap_mapping_memberof_attribute', 'memberOf' );
								   	 $mapping_memberof_attribute = get_option('mo_ldap_mapping_memberof_attribute');
								   ?>
								<input type="text" name="mapping_memberof_attribute" required="true" placeholder="Group Attributes Name" style="width:100%;" value="<?php echo $mapping_memberof_attribute;?>">
							</td>
						</tr>
						<tr><td>&nbsp;</td></tr>
						<?php } ?>
						<tr>
							<td><input type="submit" class="button button-primary button-large" value="Save Mapping"/></td>
							<td>&nbsp;</td>
						</tr>
						
					</table>
				</div>
			</form>
			
			<form method="post" id="rolemappingtest">
			<br>
				<h3>Test Role Mapping Configuration</h3>
				<?php if(get_option('mo_ldap_free_version')){ echo 'Default role is assigned to all users now. This feature is available in <b>Premium version.</b><br>'; } ?>
				Enter LDAP username to test role mapping configuration
				<table id="attributes_table" class="mo_ldap_settings_table">
					<tbody><tr></tr>
					<tr></tr>
					<tr>
						<td>Username</td>
						<td><input type="text" id="mo_ldap_username" name="mo_ldap_username" <?php if(get_option('mo_ldap_free_version')){ echo 'disabled'; } ?>  placeholder="Enter Username" style="width:61%;">
					</td></tr>
					<tr>
					<!--<td><input type="submit" value="Test Configuration" class="button button-primary button-large" /></td>-->
					<td><input type="button" value="Test Configuration" class="button button-primary button-large" onclick="testCloudRoleMappingConfiguration()" <?php if(get_option('mo_ldap_free_version')){ echo 'disabled'; } ?>></td>
					</tr>
				</tbody></table>
			</form>
			<br><br>
</div>
<script>
	jQuery( document ).ready(function() {
		jQuery("#default_group_mapping option[value='administrator']").remove();
	});
	jQuery('#enable_ldap_role_mapping').change(function() {
		jQuery('#enable_role_mapping_form').submit();
	});
	jQuery('#add_mapping').click(function() {
		var last_index_name = jQuery('#ldap_role_mapping_table tr:last .mo_ldap_table_textbox').attr('name');
		var splittedArray = last_index_name.split("_");
		var last_index = parseInt(splittedArray[splittedArray.length-1])+1;
		var dropdown = jQuery("#wp_roles_list").html();
		var new_row = '<tr><td><input class="mo_ldap_table_textbox" type="text" placeholder="cn=group,dc=domain,dc=com" name="mapping_key_'+last_index+'" value="" /></td><td><select name="mapping_value_'+last_index+'" style="width:100%" id="role">'+dropdown+'</select></td></tr>';
		jQuery('#ldap_role_mapping_table tr:last').after(new_row);
	});
	jQuery("#rolemappingtest").submit(function(event ) {
		event.preventDefault();
		testCloudRoleMappingConfiguration();
	});
	function testCloudRoleMappingConfiguration(){
		var username = jQuery("#mo_ldap_username").val();
		var myWindow = window.open('<?php echo site_url(); ?>' + '/?option=testcloudrolemappingconfig&user='+username, "Test Attribute Configuration", "width=600, height=600");	
	}
</script>
<script>
	<?php if (!Mo_Ldap_Util::is_customer_registered()) { ?>
		jQuery( document ).ready(function() {
				jQuery("#enable_role_mapping_form :input").prop("disabled", true);
				jQuery("#enable_role_mapping_form :input[type=text]").val("");
				jQuery("#enable_role_mapping_form :input[type=url]").val("");
				jQuery("#role_mapping_form :input").prop("disabled", true);
				jQuery("#role_mapping_form :input[type=text]").val("");
				jQuery("#role_mapping_form :input[type=url]").val("");
			});
	<?php } ?>
</script>
<?php
}
/* End of Role Mapping */


/* Attribute Mapping */

function mo_ldap_cloud_attribute_mapping_page(){ 

	?>
		<div class="mo_ldap_table_layout">
			<form name="f" method="post" id="attribute_config_form">
				<table id="attributes_table" class="mo_ldap_settings_table">
					
						<input type="hidden" name="option" value="mo_ldap_cloud_save_attribute_config" />
						<h3>Attribute Configuration</h3>
						<tr>
							<td><input type="checkbox" id="enable_update_cloud_ldap" name="enable_update_ldap"  value="1" <?php checked(get_option('mo_ldap_enable_attribute_mapping') == 1);?>  />Enable Attribute Mapping</td>
						</tr>
						<tr>
							<td style="width:70%;"><br>Configure LDAP attribute names for below attributes.</td>
						</tr>
						<tr>
							<td style="width:40%;"><b><font color="#FF0000">*</font>Email Attribute</b></td>
							<td><input type="text" name="mo_ldap_email_attribute" required placeholder="Enter Email attribute" style="width:100%;" 
							value="<?php echo get_option('mo_ldap_email_attribute');?>"/></td>
						</tr>
						<tr>
							<td style="width:40%;"><b><font color="#FF0000">*</font>Phone Attribute</b></td>
							<td><input type="text" name="mo_ldap_phone_attribute" required placeholder="Enter Phone attribute" style="width:100%;" 
							value="<?php echo get_option('mo_ldap_phone_attribute');?>"/></td>
						</tr>
						<tr>
							<td style="width:40%;"><b><font color="#FF0000">*</font>First Name Attribute</b></td>
							<td><input type="text" name="mo_ldap_fname_attribute" required placeholder="Enter First Name attribute" style="width:100%;" 
							value="<?php echo get_option('mo_ldap_fname_attribute');?>" /></td>
						</tr>
						<tr>
							<td style="width:40%;"><b><font color="#FF0000">*</font>Last Name Attribute</b></td>
							<td><input type="text" name="mo_ldap_lname_attribute" required placeholder="Enter Last Name attribute" style="width:100%;" 
							value="<?php echo get_option('mo_ldap_lname_attribute');?>" /></td>
						</tr>
						<?php
							$custom_attributes = array();
							$wp_options = wp_load_alloptions();
							foreach($wp_options as $option=>$value){
								if(strpos($option, "mo_ldap_custom_attribute") === false){
									//Do nothing
								} else{
									?><tr>
										<td><b><font color="#FF0000"></font><?php echo $value; ?> Attribute</b></td>
										<td><b><?php echo get_option($option); ?></b></td>
										<td><a style="cursor:pointer;" onclick="deleteAttribute('<?php echo $value; ?>');">Delete</a></td>
									</tr><?php
								}
							}
						?>
						<tr><td><h3>Add Custom Attributes</h3></td></tr>
						<?php if(get_option('mo_ldap_free_version')){ ?>
							<tr><td><br><b>Support for custom profile attributes from LDAP is present in the <a href="<?php echo add_query_arg( array('tab' => 'pricing'), $_SERVER['REQUEST_URI'] ); ?>">Premium version </a> of the plugin.</b></i><br><br></td></tr>
						<?php } else{ ?>
						
						<tr>
							<td>Enter extra LDAP attributes which you wish to be included in the user profile</td>
						</tr>
						<tr>
							<td><input type="text" name="mo_ldap_custom_attribute_1_name" placeholder="Custom Attribute Name" style="width:61%;" /></td>
							<td><input type="button" name="add_attribute" value="+" onclick="add_custom_attribute();" class="button button-primary" />&nbsp;
							<input type="button" name="remove_attribute" value="-" onclick="remove_custom_attribute();" class="button button-primary" /></td>
						</tr>
						
						<?php } ?>
						<tr id="save_config_element">
							<td>
								<input type="submit" value="Save Configuration" class="button button-primary button-large" />
							</td>
						</tr>
					
				</table>
			</form>

			<form id="delete_custom_attribute_form" method="post">
				<input type="hidden" name="option" value="mo_ldap_delete_custom_attribute" />
				<input type="hidden" id="custom_attribute_name" name="custom_attribute_name" value="" />
			</form> 
			
			<form method="post" id="attribiteconfigtest" hidden>
				<input type="hidden" name="option" value="mo_ldap_test_attribute_configuration" />
				<table id="attributes_table" class="mo_ldap_settings_table">
					<tr><h3>Test Attribute Configuration</h3></tr>
					<tr>Enter LDAP username to test attribute configuration</tr>
					<tr>
						<td>Username</td>
						<td><input type="text" id="mo_ldap_username" name="mo_ldap_username" required placeholder="Enter Username" style="width:61%;" />
					</tr>
					<tr>
					<!--<td><input type="submit" value="Test Configuration" class="button button-primary button-large" /></td>-->
					<td><input type="button" value="Test Configuration" class="button button-primary button-large" onclick="testConfiguration()" /></td>
					</tr>
				</table>
			</form>
			<script>
			
			<?php if (!Mo_Ldap_Util::is_customer_registered()) { ?>
				jQuery( document ).ready(function() {
						jQuery("#attribute_config_form :input").prop("disabled", true);
						jQuery("#attribute_config_form :input[type=text]").val("");
						jQuery("#attribute_config_form :input[type=url]").val("");
						jQuery("#attribute_config_form :input").prop("disabled", true);
						jQuery("#attribute_config_form :input[type=text]").val("");
						jQuery("#attribute_config_form :input[type=url]").val("");
					});
			<?php } ?>
			
			jQuery("#attribiteconfigtest").submit(function(event ) {
				event.preventDefault();
				testConfiguration();
			});
			
			function testConfiguration(){
				var username = jQuery("#mo_ldap_username").val();
				var myWindow = window.open('<?php echo site_url(); ?>' + '/?option=testldapattrconfig&user='+username, "Test Attribute Configuration", "width=600, height=600");	
			}
			
			
			var countAttributes;
			function add_custom_attribute(){
				countAttributes += 1;
				jQuery("<tr id='row_" + countAttributes + "'><td><input type='text' id='mo_ldap_custom_attribute_" + countAttributes + "_name' name='mo_ldap_custom_attribute_" + countAttributes + "_name' placeholder='Custom Attribute Name' style='width:61%;' /></td></tr>").insertBefore(jQuery("#save_config_element"));
			}

			function remove_custom_attribute(){
				jQuery("#row_" + countAttributes).remove();
				countAttributes -= 1;
				if(countAttributes == 0)
					countAttributes = 1;
			}

			function deleteAttribute(attributeName){
				jQuery("#custom_attribute_name").val(attributeName);
				jQuery("#delete_custom_attribute_form").submit();
			}

			jQuery(document).ready(function(){
				countAttributes = 1;
			});
			
			</script>
		</div>
<?php
}

/* End of attribute mapping */

function mo_ldap_troubleshooting(){
	?>
	
	<div class="mo_ldap_table_layout">
		<table class="mo_ldap_help">
					<tbody><tr>
						<td class="mo_ldap_help_cell">
							<div id="help_curl_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">How to enable PHP cURL extension? (Pre-requisite)</div>
							</div>
							<div hidden="" id="help_curl_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>Step 1:&nbsp;&nbsp;&nbsp;&nbsp;Open php.ini file located under php installation folder.</li>
									<li>Step 2:&nbsp;&nbsp;&nbsp;&nbsp;Search for <b>extension=php_curl.dll</b>. </li>
									<li>Step 3:&nbsp;&nbsp;&nbsp;&nbsp;Uncomment it by removing the semi-colon(<b>;</b>) in front of it.</li>
									<li>Step 4:&nbsp;&nbsp;&nbsp;&nbsp;Restart the Apache Server.</li>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
				
					<tr>
						<td class="mo_ldap_help_cell">
							<div id="help_ldap_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">Allow access from Firewall (Pre-requisite)</div>
							</div>
							<div hidden="" id="help_ldap_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>You need to allow incoming requests from hosts - <font style="color:blue">52.6.168.155</font> and <font style="color:blue">52.6.204.243</font> by a firewall rule for the port <font style="color:blue">389</font>(<font style="color:blue">636</font> for SSL or ldaps) on LDAP Server.</li>
									<li>You can follow steps here : <a href="http://www.rackspace.com/knowledge_center/article/create-an-inbound-port-allow-rule-for-windows-firewall-2008" target="_blank">http://www.rackspace.com/knowledge_center/article/create-an-inbound-port-allow-rule-for-windows-firewall-2008</a></li>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
					<tr>
						<td class="mo_ldap_help_cell">
						<div id="help_ping_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">Why is Contact LDAP Server not working?</div>
							</div>
							<div hidden="" id="help_ping_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>1.&nbsp;&nbsp;&nbsp;&nbsp;Check your LDAP Server URL to see if it is correct.<br>
									 eg. ldap://myldapserver.domain:389 , ldap://89.38.192.1:389. When using SSL, the host may have to take the form ldaps://host:636.</li>
									<li>2.&nbsp;&nbsp;&nbsp;&nbsp;Your LDAP Server may be behind a firewall. Check if the firewall is open to allow requests from hosts - <font style="color:blue">52.6.168.155</font> and <font style="color:blue">52.6.204.243</font> and the port <font style="color:blue">389</font>(<font style="color:blue">636</font> for SSL or ldaps) on LDAP Server.</li>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
					<tr>
						<td class="mo_ldap_help_cell">
							<div id="help_invaliddn_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">Why is Test LDAP Configuration not working?</div>
							</div>
							<div hidden="" id="help_invaliddn_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>1.&nbsp;&nbsp;&nbsp;&nbsp;Check if you have entered valid Service Account DN(distinguished Name) of the LDAP server. <br>e.g. cn=username,cn=group,dc=domain,dc=com<br>
									uid=username,ou=organisational unit,dc=domain,dc=com</li>
									<li>2.&nbsp;&nbsp;&nbsp;&nbsp;Check if you have entered correct Password for the Service Account.</li>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
					<tr>
						<td class="mo_ldap_help_cell">
							<div id="help_invalidsf_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">Why is Test Authentication not working?</div>
							</div>
							<div hidden="" id="help_invalidsf_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>1.&nbsp;&nbsp;&nbsp;&nbsp;The username/password combination you provided may be incorrect.</li>
									<li>2.&nbsp;&nbsp;&nbsp;&nbsp;You may have provided a <b>Search Base(s)</b> in which the user does not exist.</li>
									<li>3.&nbsp;&nbsp;&nbsp;&nbsp;Your <b>Search Filter</b> may be incorrect and the username mapping may be to an LDAP attribute other than the ones provided in the Search Filter</li>
									<li>4.&nbsp;&nbsp;&nbsp;&nbsp;You may have provided an incorrect <b>Distinguished Name attribute</b> for your LDAP Server.
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
					<tr>
						<td class="mo_ldap_help_cell">
							<div id="help_seracccre_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">What are the LDAP Service Account Credentials?</div>
							</div>
							<div hidden="" id="help_seracccre_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>1.&nbsp;&nbsp;&nbsp;&nbsp;Service account is an non privileged user which is used to bind to the LDAP Server. It is the preferred method of binding to the LDAP Server if you have to perform search operations on the directory.</li>
									<li>2.&nbsp;&nbsp;&nbsp;&nbsp;The distinguished name(DN) of the service account object and the password are provided as credentials.</li>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
					<tr>
						<td class="mo_ldap_help_cell">
							<div id="help_sbase_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">What is meant by Search Base in my LDAP environment?</div>
							</div>
							<div hidden="" id="help_sbase_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>1.&nbsp;&nbsp;&nbsp;&nbsp;Search Base denotes the location in the directory where the search for a particular directory object begins.</li>
									<li>2.&nbsp;&nbsp;&nbsp;&nbsp;It is denoted as the distinguished name of the search base directory object. eg: CN=Users,DC=domain,DC=com.</li>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
					<tr>
						<td class="mo_ldap_help_cell">
							<div id="help_sfilter_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">What is meant by Search Filter in my LDAP environment?</div>
							</div>
							<div hidden="" id="help_sfilter_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>1.&nbsp;&nbsp;&nbsp;&nbsp;Search Filter is a basic LDAP Query for searching users based on mapping of username to a particular LDAP attribute.</li>
									<li>2.&nbsp;&nbsp;&nbsp;&nbsp;The following are some commonly used Search Filters. You will need to use a search filter which uses the attributes specific to your LDAP environment. Confirm from your LDAP administrator.</li>
										<ul>
											<table>
												<tr><td style="width:50%">common name</td><td>(&(objectClass=*)(<b>cn</b>=?))</td></tr>
												<tr><td>email</td><td>(&(objectClass=*)(<b>mail</b>=?))</td></tr> 
												<tr><td>logon name</td><td>(&(objectClass=*)(<b>sAMAccountName</b>=?))<br/>(&(objectClass=*)(<b>userPrincipalName</b>=?))</td></tr>
												<tr><td>custom attribute where you store your WordPress usernames use</td> <td>(&(objectClass=*)(<b>customAttribute</b>=?))</td></tr>
												<tr><td>if you store Wordpress usernames in multiple attributes(eg: some users login using email and others using their username)</td><td>(&(objectClass=*)(<b>|</b>(<b>cn=?</b>)(<b>mail=?</b>)))</td></tr>
											</table>
										</ul>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
					<tr>
						<td class="mo_ldap_help_cell">
							<div id="help_ou_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">How do users present in different Organizational Units(OU's) login into Wordpress?</div>
							</div>
							<div hidden="" id="help_ou_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>1.&nbsp;&nbsp;&nbsp;&nbsp;You can provide multiple search bases seperated by a semi-colon to ensure users present in different OU's are able to login into Wordpress.</li>
									<li>2.&nbsp;&nbsp;&nbsp;&nbsp;You can also provide the RootDN value in the Search Base so that users in all subtrees of the RootDN are able to login.</li>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
					<tr>
						<td class="mo_ldap_help_cell">
							<div id="help_loginusing_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">Some of my users login using their email and the rest using their usernames. How will both of them be able to login?</div>
							</div>
							<div hidden="" id="help_loginusing_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>1.&nbsp;&nbsp;&nbsp;&nbsp;You need to provide a search filter which checks for the username against multiple LDAP attributes.</li>
									<li>2.&nbsp;&nbsp;&nbsp;&nbsp;For example, if you have some users who login using their email and some using their username, the following search filter can be applied: (&(objectClass=*)(|(mail=?)(cn=?)))</li>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
					<tr>
						<td class="mo_ldap_help_cell">
							<div id="help_diffdist_title" class="mo_ldap_title_panel">
								<div class="mo_ldap_help_title">What are the different Distinguished Name attributes?</div>
							</div>
							<div hidden="" id="help_diffdist_desc" class="mo_ldap_help_desc" style="display: none;">
								<ul>
									<li>1.&nbsp;&nbsp;&nbsp;&nbsp;The distinguished name attribute depends on the LDAP environment.</li>
									<li>2.&nbsp;&nbsp;&nbsp;&nbsp;For example, Active Directory(AD) uses distinguishedName to store the Distinguished Name(DN) attribute</li>
								</ul>
								For any further queries, please contact us.								
							</div>
						</td>
					</tr>
					
				</tbody></table>
	</div>
	
	
	<?php

}


function mo_ldap_show_pricing_page() { 
	$plan = Mo_Ldap_Util::mo_ldap_is_customer_validated();
	
?>
		<div class="mo_ldap_table_layout">
		<table class="mo_ldap_local_pricing_table">
		<h2>Licensing Plans
		<span style="float:right">
		<input type="button" <?php if(!Mo_Ldap_Util::is_customer_registered()) echo 'disabled'?> name="check_btn" id="check_license_btn" class="button button-primary button-large" value="Check License" onclick="document.forms['mo_ldap_check_license_form'].submit();" />
		<input type="button" name="ok_btn" id="ok_btn" class="button button-primary button-large" value="OK, Got It" onclick="window.location.href='admin.php?page=mo_ldap_login&tab=config'" /></span>
		</h2><hr>
		<tr style="vertical-align:top;">
		<?php if(!$plan){?>
				<td>
				<div class="mo_ldap_local_thumbnail mo_ldap_local_pricing_free_tab" style="width:233px;">
				
				<h3 class="mo_ldap_local_pricing_header">Free</h3>
				<h4 class="mo_ldap_local_pricing_sub_header">(You are automatically on this plan)</h4>
				<p></p>
				<hr>
				
				<p class="mo_ldap_local_pricing_text" style="padding-bottom:96px;">$0<br><br><br></p>
				
				<hr>
			
				<p class="mo_ldap_local_pricing_text" style="padding-bottom:121px;">LDAP Authentications<br> (Free for 30 days),<br><br>
				Basic Role Mapping,<br>
				Basic Attribute Mapping
			    <br>
			    </p><p>&nbsp;</p>
				<hr>
				<p class="mo_ldap_local_pricing_text">Basic Support by Email</p>
				</td>
				<?php } ?>
				<td>
				<div class="mo_ldap_local_thumbnail mo_ldap_local_pricing_paid_tab" >
				
				<h3 class="mo_ldap_local_pricing_header">Do it yourself</h3>
				<p></p>
				<h4 class="mo_ldap_local_pricing_sub_header">
						<?php if(strcmp($plan,Mo_Ldap_Util::$bCode)!=0){?>
							<input type="button" style="margin-bottom:3.8%;"  class="button button-primary button-large" onclick="moldap_upgradeform('wp_ldap_cloud_basic_plan')" value="Click here to upgrade"></input>
						</h4>
						<?php }else{?>
							<input type="button" style="margin-bottom:3.8%;"   class="button button-primary button-large" onclick="moldap_upgradeform('ldap_cloud_recharge_plan')" value="Recharge"></input>
						<?php }?>
					<hr>
					
					<p class="mo_ldap_local_pricing_text">$99 - One Time Payment<br/>+<br/>
						  <select class="mo-ldap-form-control">
						    <option>&nbsp;&nbsp;&nbsp;&nbsp;$49 per 10k transaction</option>
						    <option>&nbsp;&nbsp;&nbsp;$79 per 50k transaction</option>
						    <option>&nbsp;&nbsp;$199 per 100k transaction</option>
						    <option>&nbsp;$299 per 500k transaction</option>
						    <option>$499 per 1million transaction</option>
						  </select><br>
						  [ Pay as you go ]<br/><br/><br/><br/>
					</p>
				
				
				
				
				<hr>
				
				<p class="mo_ldap_local_pricing_text" style="padding-bottom:22px !important;">
					LDAP Authentications,<br><br><br>
					Customized Role Mapping,<br>
					Customized Attribute Mapping,<br>
					Login with username, email or any LDAP attribute of choice,<br>
					Multiple Search Bases,<br>
					Multi-Site Support
				<br/><br/><br/>
				</p>
				
				<hr>
				
				<p class="mo_ldap_local_pricing_text" >Basic Support by Email</p>
				</div></td>
			
				<td>
		
				<div class="mo_ldap_local_thumbnail mo_ldap_local_pricing_free_tab" >
				<h3 class="mo_ldap_local_pricing_header">Premium</h3>
				<p></p>
				<h4 class="mo_ldap_local_pricing_sub_header">
						<?php if(strcmp($plan,Mo_Ldap_Util::$pCode)!=0){?>
							<input type="button" style="margin-bottom:3.8%;" class="button button-primary button-large" onclick="moldap_upgradeform('wp_ldap_cloud_premium_plan')" value="Click here to upgrade"></input>
						</h4>
						<?php }else{?>
							<input type="button" style="margin-bottom:3.8%;"   class="button button-primary button-large" onclick="moldap_upgradeform('ldap_cloud_recharge_plan')" value="Recharge"></input>
						<?php }?>
					<hr>
					<!--<p class="mo_registration_pricing_text">For 1+ site</p><hr>-->
					<p class="mo_ldap_local_pricing_text">$99 - One Time Payment<br/>+<br/>
						  <select class="mo-ldap-form-control" >
						    <option>&nbsp;&nbsp;&nbsp;&nbsp;$49 per 10k transaction</option>
						    <option>&nbsp;&nbsp;&nbsp;$79 per 50k transaction</option>
						    <option>&nbsp;&nbsp;$199 per 100k transaction</option>
						    <option>&nbsp;$299 per 500k transaction</option>
						    <option>$499 per 1million transaction</option>
						  </select><br>
						  [ Pay as you go ]<br/>+<br/>One Time Setup Fees<br/>( $60 per hour )<br/>
					</p>
				<hr>
				
				<p class="mo_ldap_local_pricing_text">
					LDAP Authentications,<br><br><br>
					Customized Role Mapping,<br>
					Customized Attribute Mapping,<br>
				    Login with username, email or any LDAP attribute of choice<br>
					Multiple Search Bases,<br>
					Multi-Site Support,<br>
					Customization,<br>
					Multiple LDAP Support,<br> 
					End to End Ldap Integration **<br>
				</p>
				
				<hr>
				
				<p class="mo_ldap_local_pricing_text">Premium Support Plans Available</p>
				
				</div></td>
			
		</tr>	
		</table>
		<form style="display:none;" id="loginform" action="<?php echo get_option( 'mo_ldap_host_name').'/moas/login'; ?>" 
		target="_blank" method="post">
			<input type="email" name="username" value="<?php echo get_option('mo_ldap_admin_email'); ?>" />
			<input type="text" name="redirectUrl" value="<?php echo get_option( 'mo_ldap_host_name').'/moas/initializepayment'; ?>" />
			<input type="text" name="requestOrigin" id="requestOrigin"  />
		</form>
		<form id="mo_ldap_check_license_form"   method="post">
			<input type="hidden" name="option" value="mo_ldap_check_license" />
		</form>  
		<script>
			function moldap_upgradeform(planType){
				//alert(planType);
				jQuery('#requestOrigin').val(planType);
				jQuery('#loginform').submit();
			}
			/*jQuery('#chk_license_btn').click(function(){
				alert("fvb");
				jQuery('#mo_ldap_check_license_form').submit();
			});*/
		</script>
		<br>
		<h3>* Steps to upgrade to premium plugin -</h3>
		<p>1. You will be redirected to miniOrange Login Console. Enter your password with which you created an account with us. After that you will be redirected to payment page.</p>
		<p>2. Enter you card details and complete the payment. </p>
		<p>3. On successful payment completion, come back to plugin and click on check license button to convert it to premium.</p>
		
		
		<h3>** End to End Ldap Integration - We will setup a conference and do end to end configuration for you. We provide services to do the configuration on your behalf. </h3>
		
		<h3>10 Days Return Policy -</h3>
		<p>At miniOrange, we want to ensure you are 100% happy with your purchase. If the premium plugin you purchased is not working as advertised and you’ve attempted to resolve any feature issues with our support team, which couldn't get resolved, we will refund the whole amount within 10 days of the purchase. Please email us at <a href="mailto:info@miniorange.com">info@miniorange.com</a> for any queries regarding the return policy.<br><br>
If you have any doubts regarding the licensing plans, you can mail us at <a href="mailto:info@miniorange.com">info@miniorange.com</a> or submit a query using the support form.</p>
		<br>
		
		</div>
		
	<?php }

?>